<template>
  <label
    :for="id"
    class="ui-radio-button"
    :class="{ selected: isSelected }"
    v-bind="attrs"
  >
    <input
      :id="id"
      type="radio"
      :name="groupName"
      :value="label"
      :checked="isSelected"
      :disabled="disabled"
      class="ui-radio-button__input"
      @change="setSelected"
    />
    <span class="ui-radio-button__content"><slot /></span>
  </label>
</template>

<script lang="ts" setup>
const props = defineProps({
  label: {
    type: String,
    required: true,
  },
  disabled: {
    type: Boolean,
    default: false,
  },
});
const id = ref<string>(
  "ui-radio-" + (Math.random() + 1).toString(36).substring(2, 8)
);
// @ts-ignore
const { selected, groupName } = inject(RADIO_GROUP_KEY);
const isSelected = computed(() => selected.value === props.label);
const setSelected = (_: Event): void => {
  selected.value = props.label;
};
const attrs = computed(() => {
  const data: { disabled?: boolean } = {};
  if (props.disabled) {
    data.disabled = props.disabled;
  }
  return data;
});
</script>

<style scoped lang="scss">
.ui-radio-button {
  position: relative;
  cursor: pointer;
  &[disabled="true"] {
    cursor: not-allowed;
  }
  &__input {
    position: absolute;
    top: 0;
    left: 0;
    width: 0;
    height: 0;
  }
}
</style>
